#
# R Script zur Lösung MMM Übung 07
# Autor: Christoph Dalitz
# Datum: 23.07.2013
#

if (!interactive()) { postscript("ueb07-plot.ps") }

mu <- 1
sigma <- 2

N <- 50 # number of random samples
x <- rnorm(N,mu,sigma)
bw <- 1

xx <- seq(min(x),max(x),by=0.01)
yy <- dnorm(xx,mu,sigma)
plot(xx,yy,ylim=c(0,max(yy)*1.5),type="l",col="red",xlab="x",ylab="p(x)")

hist(x,freq=FALSE,add=TRUE,border="blue")

d <- density(x,kernel="rectangular",bw=bw)
lines(d,col="green")

d <- density(x,kernel="gaussian",bw=bw)
lines(d,col="cyan")

legend("topright",c("true density","floating histogram","gaussian kernel","histogram"),lty=c(1,1,1,1),col=c("red","green","cyan","blue"))
