#
# R Script zur Lösung MMM Übung 8.2
# Autor: Christoph Dalitz
# Datum: 27.08.2013
#

library(class)
#library(mvtnorm)

# select random subset for training, rest for testing
n <- 75
ntest <- 150 - n
train <- sample(1:150, n)
iris.train <- iris[train,]
iris.test <- iris[-train,]

# kNN recognition rate
k <- 3
iris.knn <- knn(iris.train[,-5], iris.test[,-5], iris.train[,5], k=k)
correct <- sum(iris.knn == iris.test[,5]) / ntest
print(sprintf("Erkennungsrate kNN: %3.2f", correct))


# Gauss Bayesian classifier recognition rate
## ci <- 5 # class index
## classes <- levels(iris[,ci])
## # train
## meanlist <- list()
## covlist <- list()
## i <- 0
## for (cl in classes) {
##   i <- i + 1
##   covlist[[i]] <- cov(iris.train[iris.train$Species==cl,][,-ci])
##   meanlist[[i]] <- mean(iris.train[iris.train$Species==cl,][,-ci])
## }
## # test
## correct <- 0
## for (j in 1:ntest) {
##   t <- iris.test[j,]
##   maxprob <- 0
##   maxclass <-0
##   for (i in 1:length(classes)) {
##     prob <- dmvnorm(t[,-ci], meanlist[[i]], covlist[[i]])
##     if (prob > maxprob) {
##       maxprob <- prob
##       maxclass <- i
##     }
##   }
##   if (classes[[maxclass]] == t$Species) {
##     correct <- correct + 1
##   }
## }
## correct <- correct / ntest
## print(sprintf("Erkennungsrate Gaussian Bayes: %3.2f", correct))

source("gaussian.bayes.r")
iris.bayes <- gaussian.bayes(iris.train[,-5], iris.test[,-5], iris.train[,5])
correct <- sum(iris.bayes == iris.test[,5]) / ntest
print(sprintf("Erkennungsrate Gaussian Bayes: %3.2f", correct))
