#
# R Script zur Lösung MMM Übung 15.2
# Autor: Christoph Dalitz
# Datum: 20.01.2014
#

library(MASS)

source("scatter.matrices.r")

if (!interactive()) { postscript("ueb15-2-plot.ps") }

#nosetosa <- iris[iris$Species != "setosa",]
#nosetosa$Species <- factor(nosetosa$Species)

features <- iris[,-5]

## # PCA von Hand
## S <- cov(features)
## eig <- eigen(S)
## scaled.features <- as.matrix(features) %*% eig$vectors 
## scatter.plot(scaled.features[,c(1,2)], iris$Species)

# PCA mit cmdscale
dists <- dist(features)
scaled.features <- cmdscale(dists)
x11()
scatter.plot(scaled.features, iris$Species, title="PCA")

# Sammons MDS
iris.unique <- unique(iris)
features.unique <- iris.unique[, -5]
dists <- dist(features.unique)
scaled.features <- sammon(dists)
x11()
scatter.plot(scaled.features$points, iris.unique$Species, title="Sammon")

# Kruskals MDS
scaled.features <- isoMDS(dists)
x11()
scatter.plot(scaled.features$points, iris.unique$Species, title="Kruskal")
