#
# R Script zur Lösung MMM Übung 15
# Autor: Christoph Dalitz
# Datum: 03.09.2013
#

source("scatter.matrices.r")

if (!interactive()) { postscript("ueb17-plot.ps") }

nosetosa <- iris[iris$Species != "setosa",]
nosetosa$Species <- factor(nosetosa$Species)

features <- nosetosa[, c(2,4)]

# PCA
S <- cov(features)
eig <- eigen(S)
scatter.plot(features, nosetosa$Species)
xm <- mean(features)
x1 <- xm - eig$vectors[,1]
x2 <- xm + eig$vectors[,1]
lines(c(x1[1], x2[1]), c(x1[2], x2[2]), col="blue")

# LDA
classes <- levels(nosetosa$Species)
Sw <- scatter.within(features, nosetosa$Species)
m1 <- mean(features[nosetosa$Species == classes[1],])
m2 <- mean(features[nosetosa$Species == classes[2],])
discr <- solve(Sw) %*% (m1 - m2)
discr <- discr / sqrt(sum(discr^2))
xm <- mean(features)
x1 <- xm - discr
x2 <- xm + discr
lines(c(x1[1], x2[1]), c(x1[2], x2[2]), col="magenta")

# Alternative: verwende MASS:lda
library(MASS)
res <- lda(features, nosetosa$Species)
print("Result of R-function lda:", quote=FALSE)
print(res$scaling[,1])
print("Result of direct computation:", quote=FALSE)
print(discr)

